﻿using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Styx;
using Styx.WoWInternals;

#region [Method] - Class Redundancy
using SB = RogueFirst.Core.Helpers.Spell_Book;
using HkM = RogueFirst.Core.Managers.Hotkey_Manager;
using L = RogueFirst.Core.Utilities.Log;
#endregion

namespace RogueFirst.Core
{
    static class Unit
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } } 

        #region [Method] - Active Enemies
            public static IEnumerable<WoWUnit> activeEnemies(WoWPoint fromLocation, double Range)
            {
                var Hostile = enemyCount;
                return Hostile != null ? Hostile.Where(x => x.Location.DistanceSqr(fromLocation) < Range * Range) : null;
            }

            private static List<WoWUnit> enemyCount { get; set; }

            public static void enemyAnnex(double Range)
            {
                enemyCount.Clear();
                foreach (var u in surroundingEnemies())
                {
                    if (u == null || !u.IsValid)
                        continue;
                    if (!u.IsAlive || u.DistanceSqr > Range * Range)
                        continue;
                    if (!u.Attackable || !u.CanSelect)
                        continue;
                    if (u.IsFriendly)
                        continue;
                    if (u.IsNonCombatPet && u.IsCritter)
                        continue;
                    enemyCount.Add(u);
                }
            }

            private static IEnumerable<WoWUnit> surroundingEnemies() { return ObjectManager.GetObjectsOfTypeFast<WoWUnit>(); }

            static Unit() { enemyCount = new List<WoWUnit>(); } 
        #endregion

        #region [Method] - Aura Detection
            public static bool auraExists(this WoWUnit Unit, int auraID, bool isMyAura = false)
            {
                try
                {
                    if (Unit == null || !Unit.IsValid)
                        return false;
                    WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                    return Aura != null;
                }
                catch (Exception xException)
                {
                    L.diagnosticLog("Exception in auraExists(): ", xException);
                    return false;
                }
            } 

            public static uint auraStacks(this WoWUnit Unit, int auraID, bool isMyAura = false)
            {
                try
                {
                    if (Unit == null || !Unit.IsValid)
                        return 0;                
                    WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                    return Aura != null ? Aura.StackCount : 0;
                }
                catch (Exception xException)
                {
                    L.diagnosticLog("Exception in auraStacks(): ", xException);
                    return 0;
                }
            }

            public static double auraTimeLeft(this WoWUnit Unit, int auraID, bool isMyAura = false)
            {
                try
                {
                    if (Unit == null || !Unit.IsValid)
                        return 0;
                    WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                    return Aura != null ? Aura.TimeLeft.TotalMilliseconds : 0;
                }
                catch (Exception xException)
                {
                    L.diagnosticLog("Exception in auraTimeLeft(): ", xException);
                    return 9999;
                }
            } 
        #endregion

        #region [Method] - Cache
            //public static bool auraBlindside;
            //public static bool auraSliceAndDice;
            //public static bool auraRupture;
            //public static bool auraVanish;
            //public static bool auraBurstOfSpeed;
            //public static bool auraRecuperate;
            //public static bool auraDeadlyPoison;
            //public static bool auraStealth;
            ////public static bool auraWoundPoison;
            ////public static bool auraCripplingPoison;
            ////public static bool auraMindNumbingPoison;
            ////public static bool auraLeechingPoison;
            //public static uint Energy;
            //public static int ComboPoints;
            //public static double timeleftSliceAndDice;
            //public static double timeleftRupture;
            //public static double timeleftBurstOfSpeed;
            //public static double timeleftRecuperate;

            public static void Cache()
            {

            }

            //public static bool auraOnMe;
            //public static bool auraOnTarget;
            //public static uint auraStackOnMe;
            //public static uint auraStackOnTarget;
            //public static uint mainResource;

            //public static void Cache()
            //{
            //    auraOnMe = auraExists(Me, SB.auraName);
            //    auraOnTarget = auraExists(currentTarget, SB.auraName, true);
            //    auraStackOnMe = auraStacks(Me, SB.auraName);
            //    auraStackOnTarget = auraStacks(currentTarget, SB.auraName, true);
            //    mainResource = playerPower();
            //}  
        #endregion

        #region [Method] - Unit Evaluation
            public static bool isUnitValid(this WoWUnit Unit, double Range)
            {
                return Unit != null && Unit.IsValid && Unit.IsAlive && Unit.Attackable && Unit.DistanceSqr <= Range * Range;
            }
            
            public static bool isUnitValidMelee(this WoWUnit Unit)
            {
                return Unit != null && Unit.IsValid && Unit.IsAlive && Unit.Attackable && !Unit.IsFriendly && Unit.IsWithinMeleeRangeOf(Me);
            }

        
        public static bool isUnitGettingAway(this WoWUnit Unit, double Range)
            {
                return Unit != null && Unit.IsValid && Unit.IsAlive && Unit.Attackable  && Unit.DistanceSqr >= Range * Range;
            }  
        #endregion
    }
}
