﻿using Styx;
using Styx.Common;
using Styx.CommonBot.Routines;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;

#region [Method] - Class Redundancy
    using HkM = RogueFirst.Core.Managers.Hotkey_Manager;
    using R = RogueFirst.Rotation.Rotation;
    using U = RogueFirst.Core.Unit;
#endregion 

namespace RogueFirst
{
    public class Main : CombatRoutine
    {
        private static readonly Version version = new Version(4, 0, 0);
        public override string Name { get { return "AeV's Rogue Routine" + version; } }
        public override WoWClass Class { get { return WoWClass.Rogue; } }
        public static WoWSpec MySpec { get { return Me.Specialization; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        

        #region [Method] - Implementations
            private Composite _preCombatBehavior, _combatBuffBehavior, _combatBehavior;
            public override Composite PreCombatBuffBehavior { get { return _preCombatBehavior ?? (_preCombatBehavior = R.preCombatBuffing()); } }
            public override Composite CombatBuffBehavior { get { return _combatBuffBehavior ?? (_combatBuffBehavior = R.combatBuffing()); } }
            public override Composite CombatBehavior { get { return _combatBehavior ?? (_combatBehavior = R.rotationSelector()); } }

            #region [Method] - Hidden Overrides
                public override void Initialize()
                {
                    Logging.Write(Colors.Chartreuse, "Hey {0}!", Me.Name);
                    Logging.Write(Colors.White, "");
                    Logging.Write(Colors.Chartreuse, "AeV's Rogue Routine ({0})", MySpec);
                    Logging.Write(Colors.White, "");
                    HkM.registerHotKeys();
                }
                public override bool WantButton { get { return true; } }
                public override void OnButtonPress() { Logging.Write(Colors.OrangeRed, "No gui yet!"); }
                public override void ShutDown() { HkM.removeHotkeys(); }
            #endregion 

            #region [Method] - Pulse
                public override void Pulse()
                {
                    if (!StyxWoW.IsInWorld || Me == null || !Me.IsValid || !Me.IsAlive)
                        return;

                    if (HkM.autoaoeOn)
                    {
                        if (U.activeEnemies(Me.Location, 8).Count() > 2)                 //FOR AUTO AOE
                            HkM.aoeOn = true;
                        else
                            HkM.aoeOn = false;
                    }

                    if (!Me.Combat)
                        return;
                    U.Cache();
                    U.enemyAnnex(30);
                }
            #endregion  

        #endregion

    }
}