﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx.WoWInternals;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using Styx;

#region [Method] - Class Redundancy
using C = RogueFirst.Rotation.Conditions;
using HkM = RogueFirst.Core.Managers.Hotkey_Manager;
using SB = RogueFirst.Core.Helpers.Spell_Book;
using TM = RogueFirst.Core.Managers.Talent_Manager;
using U = RogueFirst.Core.Unit;
using S = RogueFirst.Core.Spell;
#endregion

namespace RogueFirst.Rotation
{
    class Conditions
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }

        #region [Method] - Combo Points Builders

            #region [Method] - Dispatch
            public static Composite Dispatch(WoWUnit Unit, double Range)          //DISPATCH
                {
                    return S.Cast(SB.spellDispatch, ret => U.isUnitValid(Unit, Range));
                }
            #endregion 

            #region [Method] - Mutilate
                public static Composite Mutilate(WoWUnit Unit, double Range)            //MUTILATE
                {
                    return S.Cast(SB.spellMutilate, ret => U.isUnitValid(Unit, Range));
                }
            #endregion

            #region [Method] - Fan of Knives
                public static Composite FanOfKnives()                                             //FAN OF KNIVES
                {
                    return S.blindCast(SB.spellFanOfKnives, ret => true);
                }
            #endregion 

        #endregion
        
        #region [Method] - Finishing Moves

            #region [Method] - Slice And Dice
                public static Composite SliceAndDice()                                             //SLICE AND DICE
                {
                    return S.blindCast(SB.spellSliceAndDice, ret => true);
                }
            #endregion  

            #region [Method] - Recuperate
                public static Composite Recuperate()                                             //RECUPERATE
                {
                    return S.blindCast(SB.spellRecuperate, ret => true);
                }
            #endregion  
        
            
            #region [Method] - Rupture
                public static Composite Rupture(WoWUnit Unit, double Range)                          //RUPTURE
                {
                    return S.Cast(SB.spellRupture, ret => U.isUnitValid(Unit, Range)); 
                }
            #endregion  

            #region [Method] - Envenom
                public static Composite Envenom(WoWUnit Unit, double Range)                     //ENVENOM
                {
                    return S.Cast(SB.spellEnvenom, ret => U.isUnitValid(Unit, Range));
                }
            #endregion

        #endregion
                
        #region [Method] - Other Abilities / Talents
            
            #region [Method] - Stealth
                public static Composite Stealth()                          //Stealth
                {
                    return S.blindCast(SB.spellStealth, ret => true);
                }
            #endregion 

            #region [Method] - Burst Of Speed
                public static Composite BurstOfSpeed()                          //Burst Of Speed
                {
                    return S.blindCast(SB.spellBurstOfSpeed, ret => true);
                }
            #endregion 

            #region [Method] - Sap
                public static Composite Sap(WoWUnit Unit, double Range)                          //SAP
                {
                    return S.Cast(SB.spellSap, ret => U.isUnitValid(Unit, Range));
                }
            #endregion  


            #region [Method] - Vendetta
                public static Composite Vendetta(WoWUnit Unit, double Range)                          //VENDETTA
                {
                    return S.Cast(SB.spellVendetta, ret => U.isUnitValid(Unit, Range));
                }
            #endregion  


            #region [Method] - PickPocket
                public static Composite PickPocket(WoWUnit Unit, double Range)                          //PickPocket
                {
                    return S.Cast(SB.spellPickPocket, ret => U.isUnitValid(Unit, Range));
                }
            #endregion  

            #region [Method] - Deadly Poison
                public static Composite DeadlyPoison()                                   //Deadly Poison
                {
                    return S.blindCast(SB.PoisonDeadlyPoison, ret => true);
                }
            #endregion 

            #region [Method] - Wound Poison
                public static Composite WoundPoison()                                   //Wound Poison
                {
                    return S.blindCast(SB.PoisonWound, ret => true);
                }
            #endregion 

            #region [Method] - Crippling Poison
                public static Composite CripplingPoison()                             //Crippling Poison
                {
                    return S.blindCast(SB.PoisonCrippling, ret => true);
                }
            #endregion 

            #region [Method] - MindNumbing Poison
                public static Composite MindNumbingPoison()                          //MindNumbing Poison
                {
                    return S.blindCast(SB.PoisonMindNumbing, ret => true);
                }
            #endregion 

            #region [Method] - Leeching Poison
                public static Composite LeechingPoison()                            //Leeching Poison
                {
                    return S.blindCast(SB.PoisonLeeching, ret => true);
                }
            #endregion 

        #endregion

                //#region [Method] - Auto Attack
                //private static Composite autoAttack()
                //{
                //    return new Action(ret =>
                //    {
                //        if (!Me.IsAutoAttacking && U.isUnitValid(currentTarget, 5))
                //            Lua.DoString("StartAttack()");
                //        return RunStatus.Failure;
                //    });
                //}
                //#endregion 

                //#region [Method] - Blood Tap
                //public static Composite bloodTap()
                //{
                //    return S.blindCast(SB.spellBloodTap, ret => U.bloodCharge > 4 && (U.bloodRunes == 0 || U.frostRunes == 0 || U.unholyRunes == 0), true);
                //}
                //#endregion  

                //#region [Method] - Horn of Winter
                //public static Composite hornofWinter()
                //{
                //    return S.Buff(SB.spellHornofWinter, ret => true);
                //}
                //#endregion  

                //#region [Method] - Death and Decay
                //public static Composite deathandDecay(WoWUnit Unit, double Range)
                //{
                //    return S.dropCast(SB.spellDeathandDecay, ret => Unit, ret => U.isUnitValid(Unit, Range));
                //}
                //#endregion  

                //#region [Method] - Obliterate
                //public static Composite Obliterate(WoWUnit Unit, double Range)
                //{
                //    return S.Cast(SB.spellObliterate, ret => U.isUnitValid(Unit, Range));
                //}
                //#endregion  
        
    }
}
