﻿using CommonBehaviors.Actions;
using Styx;
using Styx.TreeSharp;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

#region [Method] - Class Redundancy
using C = RogueFirst.Rotation.Conditions;
using HkM = RogueFirst.Core.Managers.Hotkey_Manager;
using SB = RogueFirst.Core.Helpers.Spell_Book;
using TM = RogueFirst.Core.Managers.Talent_Manager;
using U = RogueFirst.Core.Unit;
using S = RogueFirst.Core.Spell;
using System.Windows.Input;
using System.Windows.Forms;
#endregion

namespace RogueFirst.Rotation
{
    class Rotation
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        public static WoWSpec MySpec { get { return Me.Specialization; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        private static WoWUnit Focused { get { return StyxWoW.Me.FocusedUnit; } }
        
        

        #region [Method] - Combat Buffing
        public static Composite combatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || !Me.GotTarget, new ActionAlwaysSucceed())
                );
        }
        #endregion

        #region [Method] - Precombat Buffing
        public static Composite preCombatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || Me.IsCasting || Me.IsChanneling || Me.Mounted || Me.OnTaxi || HkM.IsKeyDown(Keys.LMenu), new ActionAlwaysSucceed()),
                //new Decorator(ret => !U.auraExists(Me, SB.PoisonDeadlyPoison) || U.auraTimeLeft(Me, SB.PoisonDeadlyPoison) < 1000 * 60 * 10, C.DeadlyPoison()),                     //DEADLY POISON
                S.Buff(SB.spellBurstOfSpeed, ret => HkM.AlwaysSpeedOn && Me.IsMoving && (!U.auraExists(Me, SB.auraBurstOfSpeed) || U.auraTimeLeft(Me, SB.auraBurstOfSpeed) < 1000) && !Me.Combat),
				S.Buff(SB.spellBladeFlurry, ret => HkM.aoeOn  && !U.auraExists(Me, SB.spellBladeFlurry)), 		//BLADEFLURRY CAST
				S.Buff(SB.spellBladeFlurry, ret => !HkM.aoeOn && U.auraExists(Me, SB.spellBladeFlurry)),       //BLADEFLURRY    REMOVE
                S.Buff(SB.spellStealth, ret => HkM.StealthOn && !U.auraExists(Me, SB.spellStealth))
            );
        }
        #endregion

        #region [Method] - Rotation Selector
        public static Composite rotationSelector()
        {
            return new PrioritySelector(
                new Decorator(ret => HkM.manualOn || !Me.IsAlive || !Me.GotTarget || !Me.Combat || HkM.IsKeyDown(Keys.LMenu), new ActionAlwaysSucceed()),   // PAUSE ON LEFTALT

                S.Buff(SB.spellBurstOfSpeed, ret => HkM.AlwaysSpeedOn && Me.IsMoving && (!U.auraExists(Me, SB.auraBurstOfSpeed) || U.auraTimeLeft(Me, SB.auraBurstOfSpeed) < 1000) && U.isUnitGettingAway(currentTarget, 10) && !currentTarget.IsPlayer),
                S.Buff(SB.spellBurstOfSpeed, ret => HkM.AlwaysSpeedOn && Me.IsMoving && (!U.auraExists(Me, SB.auraBurstOfSpeed) || U.auraTimeLeft(Me, SB.auraBurstOfSpeed) < 1000) && currentTarget.IsPlayer),

                S.Buff(SB.spellFeint, ret => HkM.FeintOn && !U.auraExists(Me, SB.spellFeint)), //FEINT ALWAYS IF GOT TALENT

                S.Cast(SB.spellKidneyShot, ret => HkM.IsKeyDown(Keys.LShiftKey) && Me.ComboPoints > 3 && U.isUnitValidMelee(currentTarget)),     //KIDNEY SHOT ON LEFT SHIFT

                S.Buff(SB.spellRecuperate, ret => HkM.HealingOn && Me.ComboPoints > 2 && !U.auraExists(Me, SB.spellRecuperate) && Me.HealthPercent < 90),

                //S.Buff(SB.spellSmokeBomb, ret=> HkM.IsKeyDown(Keys.LShiftKey)),     //SMOKEBOMB ON LEFTSHIFT
                //S.FocusCast(SB.spellTricksOfTheTrade, ret => Focused.IsPlayer && Focused.IsFriendly && Focused.IsAlive && Focused.InLineOfSight),     //TOT

                new Decorator(ret => U.auraExists(currentTarget, SB.spellBlind), new ActionAlwaysSucceed()),        //STOP IF TARGETTED BLINDED

                new Switch<WoWSpec>(ret => MySpec,
                 //--------------------------------------------------------------------------------------------------------------------
            #region ASSASSINATION
                    new SwitchArgument<WoWSpec>(WoWSpec.RogueAssassination,                      //ASSASSINATION
                        new Switch<bool>(ret => HkM.aoeOn,
                            new SwitchArgument<bool>(true,                  //AOE HERE
                                new PrioritySelector(
                                    S.Cast(SB.spellVendetta, ret => HkM.cooldownsOn, U.isUnitValid(currentTarget, 10)),         //VENDETTA
                                    //MORE THAN 8 AOE
                                    S.Cast(SB.spellEnvenom, ret => Me.ComboPoints > 4 && U.activeEnemies(Me.Location, 8).Count() > 8 && U.isUnitValidMelee(currentTarget)),
                                    S.blindCast(SB.spellFanOfKnives, ret => U.activeEnemies(Me.Location, 8).Count() > 8, true),

                                    //4 - 8 AOE
                                    S.Cast(SB.spellRupture, ret => Me.ComboPoints > 2 && U.activeEnemies(Me.Location, 8).Count() > 3 && U.activeEnemies(Me.Location, 8).Count() < 9 && !U.auraExists(currentTarget, SB.spellRupture, true) && U.isUnitValidMelee(currentTarget)),
                                    S.Cast(SB.spellEnvenom, ret => Me.ComboPoints > 4 && U.activeEnemies(Me.Location, 8).Count() > 3 && U.activeEnemies(Me.Location, 8).Count() < 9 && U.isUnitValidMelee(currentTarget)),
                                    S.blindCast(SB.spellFanOfKnives, ret => U.activeEnemies(Me.Location, 8).Count() > 3 && U.activeEnemies(Me.Location, 8).Count() < 9, true),

                                    //2 - 3 AOE
                                    S.Cast(SB.spellRupture, ret => Me.ComboPoints > 2 && !U.auraExists(currentTarget, SB.spellRupture, true) && U.isUnitValidMelee(currentTarget)),
                                    S.Cast(SB.spellEnvenom, ret => Me.ComboPoints > 4 && SpellManager.HasSpell("Anticipation") && U.isUnitValidMelee(currentTarget)), //with anticip
                                    S.Cast(SB.spellEnvenom, ret => ((Me.ComboPoints > 2 && !U.auraExists(Me, SB.auraBlindside)) || (Me.ComboPoints > 3 && U.auraExists(Me, SB.auraBlindside))) && !SpellManager.HasSpell("Anticipation") && U.isUnitValidMelee(currentTarget)), //without anticip
                                    S.Cast(SB.spellDispatch, ret => (U.auraExists(Me, SB.auraBlindside) || currentTarget.HealthPercent <= 35) && Me.ComboPoints < 5 && U.isUnitValidMelee(currentTarget)),
                                    S.Cast(SB.spellMutilate, ret => U.isUnitValidMelee(currentTarget))
                                )
                            ),
                            new SwitchArgument<bool>(false,                 //SINGLE TARGETTING HERE
                                new PrioritySelector(
                                    //S.Buff(SB.spellSliceAndDice, ret => Me.ComboPoints > 0 && !U.auraExists(Me, SB.spellSliceAndDice)),
                                    //S.Cast(SB.spellEnvenom, ret => Me.ComboPoints > 0 && U.auraTimeLeft(Me, SB.spellSliceAndDice) < 2000),   //REFRESH S&D
                                    S.Cast(SB.spellRupture, ret => Me.ComboPoints > 4 && SpellManager.HasSpell("Anticipation") && (!U.auraExists(currentTarget, SB.spellRupture, true) || U.auraTimeLeft(currentTarget, SB.spellRupture, true) < 5000) && U.isUnitValidMelee(currentTarget)),
                                    S.Cast(SB.spellRupture, ret => ((Me.ComboPoints > 2 && !U.auraExists(Me, SB.auraBlindside)) || (Me.ComboPoints > 3 && U.auraExists(Me, SB.auraBlindside))) && !SpellManager.HasSpell("Anticipation") && (!U.auraExists(currentTarget, SB.spellRupture, true) || U.auraTimeLeft(currentTarget, SB.spellRupture, true) < 5000) && U.isUnitValidMelee(currentTarget)),
                                    S.Cast(SB.spellEnvenom, ret => Me.ComboPoints > 4 && SpellManager.HasSpell("Anticipation") && U.isUnitValidMelee(currentTarget)), //with anticip
                                    S.Cast(SB.spellEnvenom, ret => ((Me.ComboPoints > 2 && !U.auraExists(Me, SB.auraBlindside)) || (Me.ComboPoints > 3 && U.auraExists(Me, SB.auraBlindside))) && !SpellManager.HasSpell("Anticipation") && U.isUnitValidMelee(currentTarget)), //without anticip

                                    S.Cast(SB.spellDispatch, ret => (U.auraExists(Me, SB.auraBlindside) || currentTarget.HealthPercent <= 35) && Me.ComboPoints < 5 && U.isUnitValidMelee(currentTarget)),
                                    S.Cast(SB.spellMutilate, ret => U.isUnitValidMelee(currentTarget))
                                )
                            )
                        )
                    ),
            #endregion
                 //--------------------------------------------------------------------------------------------------------------------
            #region COMBAT
                    new SwitchArgument<WoWSpec>(WoWSpec.RogueCombat,                 //COMBAT
                        new PrioritySelector(
                            S.Buff(SB.spellBladeFlurry, ret => HkM.aoeOn  && !U.auraExists(Me, SB.spellBladeFlurry)), //BLADEFLURRY CAST 
                            S.Buff(SB.spellBladeFlurry, ret => !HkM.aoeOn && U.auraExists(Me, SB.spellBladeFlurry)),       //BLADEFLURRY    REMOVE

                            //S.Buff(SB.spellPreparation, ret => HkM.cooldownsOn && !U.auraExists(Me, SB.spellVanish) && SpellManager.Spells["Vanish"].CooldownTimeLeft.TotalSeconds < 10), //PREP

                            S.Cast(SB.spellShadowReflection, ret => HkM.cooldownsOn && ((S.cooldownTimeLeft(SB.spellKillingSpree) <10000 && Me.ComboPoints >3) || U.auraExists(Me,SB.SpellAdrenalineRush))&&U.isUnitValidMelee(currentTarget)), //ADD SHADOWREFLECTION ID

                            S.Cast(SB.spellAmbush, ret => U.isUnitValidMelee(currentTarget)),    //AMBUSH 

                            //S.Buff(SB.spellVanish, ret => HkM.cooldownsOn && HkM.autoVanishOn && U.auraExists(Me, SB.auraDeepInsight) && U.isUnitValidMelee(currentTarget)),     //VANISH -NOT ADDED-

                            S.Cast(SB.spellKillingSpree, ret => HkM.cooldownsOn && Me.CurrentEnergy < 50 && (!SpellManager.HasSpell("Shadow Reflection")|| S.cooldownTimeLeft(SB.spellShadowReflection)>30000 || U.auraTimeLeft(Me,SB.spellShadowReflection)>12000) && U.isUnitValid(currentTarget, 10)),
                            S.Buff(SB.SpellAdrenalineRush, ret => HkM.cooldownsOn && Me.CurrentEnergy < 35 && U.isUnitValid(currentTarget, 10)),

                            S.Buff(SB.spellSliceAndDice, ret =>  U.auraTimeLeft(Me, SB.spellSliceAndDice) < 2000 || (U.auraTimeLeft(Me, SB.spellSliceAndDice) < 15000 && U.auraStacks(Me, SB.auraBanditsGuile) == 11 && Me.ComboPoints >= 4)),     //SLICEANDDICE

                            S.Cast(SB.spellMarkedForDeath, ret => !HkM.cooldownsOn && Me.ComboPoints<=1 && U.auraExists(currentTarget,SB.spellRevealingStrike,true) && U.isUnitValidMelee(currentTarget)),
							S.Cast(SB.spellMarkedForDeath, ret => HkM.cooldownsOn && Me.ComboPoints<=1 && U.auraExists(currentTarget,SB.spellRevealingStrike,true) && (!SpellManager.HasSpell("Shadow Reflection")|| U.auraExists(Me,SB.spellShadowReflection) ||S.cooldownTimeLeft(SB.spellShadowReflection)>30000) &&U.isUnitValidMelee(currentTarget)),

                            S.Cast(SB.spellRevealingStrike, ret => (!U.auraExists(currentTarget, SB.spellRevealingStrike, true) || U.auraTimeLeft(currentTarget, SB.spellRevealingStrike) < 2000) && (Me.ComboPoints < 5 || (SpellManager.HasSpell("Anticipation") && U.auraStacks(Me, SB.auraAnticipation) <= 4 && !U.auraExists(Me, SB.auraDeepInsight))) && U.isUnitValidMelee(currentTarget)),
                            S.Cast(SB.spellSinisterStrike, ret => (Me.ComboPoints < 5 || (SpellManager.HasSpell("Anticipation") && U.auraStacks(Me, SB.auraAnticipation) <= 4 && !U.auraExists(Me, SB.auraDeepInsight))) && U.isUnitValidMelee(currentTarget)),

                            S.Buff(SB.spellCrimsonTempest, ret => HkM.aoeOn && U.activeEnemies(Me.Location, 8).Count() > 5 && Me.ComboPoints == 5 && (U.auraExists(Me, SB.auraDeepInsight) || !SpellManager.HasSpell("Anticipation") || (SpellManager.HasSpell("Anticipation") && U.auraStacks(Me, SB.auraAnticipation) >= 4)) && U.isUnitValidMelee(currentTarget)),
							S.Buff(SB.spellCrimsonTempest, ret => HkM.aoeOn && U.activeEnemies(Me.Location, 8).Count() > 2 && !U.auraExists(currentTarget, SB.auraCrimsonTempest, true) && Me.ComboPoints == 5 && (U.auraExists(Me, SB.auraDeepInsight) || !SpellManager.HasSpell("Anticipation") || (SpellManager.HasSpell("Anticipation") && U.auraStacks(Me, SB.auraAnticipation) >= 4)) && U.isUnitValidMelee(currentTarget)),

                            S.Cast(SB.spellEviscerate, ret =>  Me.ComboPoints >= 4 && (U.auraExists(Me, SB.auraDeepInsight) || !SpellManager.HasSpell("Anticipation") || (SpellManager.HasSpell("Anticipation") && U.auraStacks(Me, SB.auraAnticipation) >= 3)) && U.isUnitValidMelee(currentTarget))

                                //((U.auraExists(Me, SB.auraModerateInsight) && Me.CurrentEnergy > 125) || !U.auraExists(Me, SB.auraModerateInsight)) &&

                            //S.Cast(SB.spellKillingSpree, ret => HkM.cooldownsOn && Me.CurrentEnergy < 20 && U.isUnitValid(currentTarget, 10)),         //KILLINGSPREE 
                            //S.Buff(SB.SpellAdrenalineRush, ret => HkM.cooldownsOn && U.isUnitValid(currentTarget, 10)),       //ADRENALINERUSH

                            //S.Buff(SB.spellSliceAndDice, ret => ((Me.ComboPoints > 4 && SpellManager.HasSpell("Anticipation")) || (Me.ComboPoints > 3 && !SpellManager.HasSpell("Anticipation"))) && (!U.auraExists(Me, SB.spellSliceAndDice) || U.auraTimeLeft(Me, SB.spellSliceAndDice) < 9000)),     //SLICEANDDICE
                            //S.Cast(SB.spellEviscerate, ret => ((Me.ComboPoints > 4 && SpellManager.HasSpell("Anticipation")) || (Me.ComboPoints > 3 && !SpellManager.HasSpell("Anticipation"))) && U.isUnitValidMelee(currentTarget)),          //EVISCERATE

                            //S.Cast(SB.spellRevealingStrike, ret => !U.auraExists(currentTarget, SB.spellRevealingStrike, true) && U.isUnitValidMelee(currentTarget)),  //REVEALING STRIKE
                            //S.Cast(SB.spellSinisterStrike, ret => U.isUnitValidMelee(currentTarget))        //SINISTER STRIKE
                        )
                    ),
            #endregion
                //---------------------------------------------------------------------------------------------------------------------
            #region SUBTLETY
                    new SwitchArgument<WoWSpec>(WoWSpec.RogueSubtlety,                 //SUBTLETY
                        new PrioritySelector(
                            //S.Cast(SB.spellShadowReflection, ret => HkM.cooldownsOn && U.auraExists(Me,SB.spellShadowDance) && U.isUnitValidMelee(currentTarget)),
                            //S.Buff(SB.spellSliceAndDice, ret => U.auraTimeLeft(Me,SB.spellSliceAndDice)<10000),
                            //S.Buff(SB.spellPremeditation, ret=> Me.ComboPoints <5 && !(U.auraExists(Me,SB.spellShadowDance)&& Me.CurrentEnergy>100 && Me.ComboPoints>1) && U.isUnitValidMelee(currentTarget)),
                            //S.Cast(SB.spellGarrote, ret=> !(U.auraExists(currentTarget, SB.spellGarrote,true) || U.auraExists(currentTarget, SB.spellRupture,true) ||U.auraExists(currentTarget, SB.spellHemo,true)) && U.isUnitValidMelee(currentTarget)),
                            //S.Cast(SB.spellAmbush, ret => (Me.ComboPoints <5 || (SpellManager.HasSpell("Anticipation") && U.auraStacks(Me, SB.auraAnticipation) < 3) && U.auraExists(Me, SB.spellShadowDance) && U.isUnitValidMelee(currentTarget)),
                            //S.Buff(SB.spellShadowDance, ret=> HkM.cooldownsOn && Me.CurrentEnergy > 50 && !U.auraExists(Me, SB.spellStealth) && !U.auraExists(Me, SB.auraVanish) && !U.auraExists(currentTarget, SB.auraFindWeakness,true) && U.isUnitValidMelee(currentTarget)),
                            //S.Cast(SB.spellMarkedForDeath, ret => Me.ComboPoints < 1  && U.isUnitValidMelee(currentTarget)),

                            S.Cast(SB.spellMarkedForDeath, ret => (Me.ComboPoints < 1 || currentTarget.HealthPercent < 20) && U.isUnitValidMelee(currentTarget)),

                            new Switch<bool>(ret => HkM.aoeOn,
                                new SwitchArgument<bool>(true,                  //AOE HERE
                                    new PrioritySelector(
                                        S.Buff(SB.spellSliceAndDice, ret => Me.ComboPoints > 3 && (!U.auraExists(Me, SB.spellSliceAndDice) || U.auraTimeLeft(Me,SB.spellSliceAndDice)<8000)),

                                        S.Cast(SB.spellShadowReflection, ret => HkM.cooldownsOn && Me.EnergyPercent > 75 && SpellManager.HasSpell("Shadow Reflection")),
                                        new Decorator(ret => HkM.cooldownsOn && Me.EnergyPercent < 75 && S.cooldownTimeLeft(SB.spellShadowReflection) < 2000 && SpellManager.HasSpell("Shadow Reflection"), new ActionAlwaysSucceed()),

                                        S.Buff(SB.spellCrimsonTempest,   ret => U.activeEnemies(Me.Location, 10).Count() >= 4 && Me.ComboPoints == 5),
                                        S.Buff(SB.spellCrimsonTempest,   ret => U.activeEnemies(Me.Location, 10).Count() < 4 && Me.ComboPoints == 5 && !U.auraExists(currentTarget, SB.auraCrimsonTempest, true)),

                                        S.blindCast(SB.spellFanOfKnives, ret => Me.ComboPoints < 5 && U.activeEnemies(Me.Location, 10).Count() > 1, true),
                                        S.Cast(SB.spellHemo, ret => Me.ComboPoints < 5 && !U.auraExists(currentTarget, SB.spellHemo, true) && U.isUnitValidMelee(currentTarget)),
                                        S.Cast(SB.spellBackstab, ret => Me.ComboPoints < 4 && Me.IsBehind(currentTarget) && U.activeEnemies(Me.Location, 10).Count() == 1 && U.isUnitValidMelee(currentTarget)),
                                        S.Cast(SB.spellHemo, ret => Me.ComboPoints < 4 && !Me.IsBehind(currentTarget) && U.activeEnemies(Me.Location, 10).Count() == 1 && U.isUnitValidMelee(currentTarget)),

                                        S.Cast(SB.spellRupture, ret => Me.ComboPoints > 3 && !U.auraExists(currentTarget, SB.spellRupture, true) && U.isUnitValidMelee(currentTarget)),
                                        S.Cast(SB.spellEviscerate, ret => Me.ComboPoints > 3 && U.isUnitValidMelee(currentTarget))
                                    )
                                ),
                                new SwitchArgument<bool>(false,                 //SINGLE TARGETTING HERE
                                    new PrioritySelector(
                                        S.Cast(SB.spellShadowReflection, ret => U.auraExists(Me, SB.spellShadowDance)),
                                        S.Buff(SB.spellShadowDance, ret => HkM.cooldownsOn && Me.EnergyPercent > 75 && U.auraExists(Me, SB.spellSliceAndDice) && U.isUnitValidMelee(currentTarget)),

                                        new Decorator(ret => HkM.cooldownsOn && Me.EnergyPercent < 75 && S.cooldownTimeLeft(SB.spellShadowDance) < 2000, new ActionAlwaysSucceed()),

                                        S.Buff(SB.spellPremeditation, ret=> Me.ComboPoints < 4),
                                        S.Cast(SB.spellAmbush, ret => Me.ComboPoints < 4 && U.isUnitValidMelee(currentTarget)),
                                        S.Cast(SB.spellHemo, ret => Me.ComboPoints < 5 && (!U.auraExists(currentTarget, SB.spellHemo, true) || U.auraTimeLeft(currentTarget, SB.spellHemo, true) < 5000) && U.isUnitValidMelee(currentTarget)),
                                        S.Cast(SB.spellBackstab, ret => Me.ComboPoints < 4 && Me.IsBehind(currentTarget) && !U.auraExists(Me, SB.spellShadowDance) && U.isUnitValidMelee(currentTarget)),
                                        S.Cast(SB.spellHemo, ret => Me.ComboPoints < 4 && (!Me.IsBehind(currentTarget) || !SpellManager.CanCast(SB.spellBackstab)) && !U.auraExists(Me, SB.spellShadowDance) && U.isUnitValidMelee(currentTarget)),
                                        
                                        S.Buff(SB.spellSliceAndDice, ret => Me.ComboPoints > 3 && (!U.auraExists(Me, SB.spellSliceAndDice) || U.auraTimeLeft(Me,SB.spellSliceAndDice)<8000)),
                                        S.Cast(SB.spellRupture, ret => Me.ComboPoints > 3  && (!U.auraExists(currentTarget, SB.spellRupture, true) || U.auraTimeLeft(currentTarget, SB.spellRupture, true) < 7000) && U.isUnitValidMelee(currentTarget)),
                                        S.Cast(SB.spellEviscerate, ret=> Me.ComboPoints > 3 && U.isUnitValidMelee(currentTarget))
                                    )
                                )
                            )
                        )
                    )
            #endregion
                )
            );
        }
        #endregion
    }
}